; NSIS v1.98: jtv.nsi
;
; It will install JTV 3.0 wip 12.6 into a directory that the user selects.
;
; Installer vervion 
!define INS_VER_MAJOR 1
!define INS_VER_MINOR 21

; Program version
!define PRG_VER_MAJOR 3
!define PRG_VER_MINOR 12.6

; Source layouts: 
; c:\dst\jtv\main\... - all structure, but only \EN subdir
; c:\dst\jtv\lang\... - all languages subdirs except \EN
; c:\dst\jtv\nsis\... - installation NSIS files (as example)
!define SRC_MAIN_DIR c:\dst\jtv\main
!define SRC_LANG_DIR c:\dst\jtv\Lang
!define SRC_NSIS_DIR c:\dst\jtv\NSIS

!define PRG_DIR JTV				; Default files directory name on drive
!define PRG_FLDR "JTV (Jaak TV)"			; Program folder name via Start/Programs
!define PRG_NAME "Jaak TV 3.0 wip 12.6"	; Program name for Windows Registry	

; Installer parameters
Name "JTV"
Icon "jtv.ico"
EnabledBitmap .\Contrib\one-check.bmp
DisabledBitmap .\Contrib\one-nocheck.bmp
BrandingText "JTV Host Installer v${INS_VER_MAJOR}.${INS_VER_MINOR}"
CRCCheck on

LicenseText "Read this to make shure, you know what you doing..."
LicenseData ${SRC_MAIN_DIR}\license.txt

; The file to write
OutFile "jtv${PRG_VER_MAJOR}w126.exe"

; The default installation directory
InstallDir $PROGRAMFILES\${PRG_DIR}
; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM SOFTWARE\${PRG_DIR} "Install_Dir"

; The text to prompt the user to enter a directory
ComponentText "This setup will install JTV ${PRG_VER_MAJOR}.0 wip (build) ${PRG_VER_MINOR} and JTVRemote 12.5 on your computer."

InstType "Full"
InstType "Typical"
InstType "Standard"
InstType "Normal"
InstType "Minimal"
;InstType /NOCUSTOM
;InstType /COMPONENTSONLYONCUSTOM

; The text to prompt the user to enter a directory
DirText "Choose a directory to install in to:"

; The stuff to be installed allways (1-st section)
Section "Install JTV main files (required)"
  SectionIn 1 2 3 4 5
  AddSize 400
; Check out path to the installation directory.
   IfFileExists "$INSTDIR\*.*" 0 NoSuchDir
     MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2  \
                "Directory $INSTDIR already exists. Sure to install into anyway?" \
                IDYES NoSuchDir 
                Quit
   NoSuchDir:

; Set output path to the installation directory.
  SetOutPath $INSTDIR
; Put file there
  File /r ${SRC_MAIN_DIR}\*.*
  CopyFiles "$INSTDIR\Languages\En\Jtv_en.ini" "$INSTDIR\Jtv.ini"
  CopyFiles "$INSTDIR\Languages\En\Readme_en.txt" "$INSTDIR\Readme.txt"
  CopyFiles "$INSTDIR\Languages\En\JTV Host_en.url" "$INSTDIR\JTV Host.url"
; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\NSIS_${PRG_DIR} "Install_Dir" "$INSTDIR"
; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRG_NAME}" \
                   "DisplayName" "${PRG_NAME} (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRG_NAME}" \
                   "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "uninstall.exe"

  ReadINIStr $R0 $7 "Field 3" State ; $R0=Selected language
  StrCpy $R1 $R0 2                  ; $R1=Selected type
  ReadINIStr $R2 $7 "Field 4" State ; $R2=Add all languages
  Call LanguageInstall
SectionEnd

; optional section
Section "Create Program Folder and Shortcuts"
  SectionIn 1 2 3 4
  CreateDirectory "$SMPROGRAMS\${PRG_FLDR}"
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\Uninstall JTV.lnk" "$INSTDIR\uninstall.exe" "" \
                 "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\JTV 3.0 wip 12.6.lnk" "$INSTDIR\JTV.exe" "" \
                 "$INSTDIR\JTV.exe" 0
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\JTVRemote .lnk" "$INSTDIR\JTVRemote.exe" "" \
                 "$INSTDIR\JTVremote.exe" 0
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\JTVConfig.lnk" "$INSTDIR\JTVConfig.exe" "" \
                 "$INSTDIR\JTVConfig.exe" 0
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\Readme.lnk" "$INSTDIR\Readme.txt" "" \
                 "$INSTDIR\Readme.txt" 0
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\JTV Host.lnk" "$INSTDIR\JTV Host.url" "" \
                 "$INSTDIR\JTV Host.url" 0
;   WriteINIStr "$SMPROGRAMS\${PRG_FLDR}\JTV Host.url" \
;               "InternetShortcut" "URL" \
;		   "http://jtvhost.narod.ru/en/"

SectionEnd

; optional section
Section "Load JTVRemote at System Startup"
  SectionIn 1 2
  CreateShortCut "$SMSTARTUP\JTVRemote.lnk" "$INSTDIR\JTVRemote.exe" "" \
                 "$INSTDIR\JTVRemote.exe" 0
SectionEnd

; optional section
Section "Create JTV Desktop Shortcut"
  SectionIn 1 3
  CreateShortCut "$DESKTOP\JTV.lnk" "$INSTDIR\JTV.exe"
SectionEnd

; optional section
Section "Create JTVRemote Desktop Shortcut"
  SectionIn 1 3
  CreateShortCut "$DESKTOP\JTVRemote.lnk" "$INSTDIR\JTVRemote.exe"
SectionEnd

Function LanguageInstall
   StrCmp $R2 1 "" OneLang
   ; All languages added to selected and copied
    SetOutPath "$INSTDIR\Languages"
    File /r ${SRC_LANG_DIR}\*.*"
    DetailPrint "All Languages Added"
   OneLang:
   ; Only one language selected and copied
    StrCmp $R1 EN AllDone
    SetOutPath "$INSTDIR\Languages\$R1"
    DetailPrint "$R0 Language Selected"
    Call SourceSelect
    ; Prepare configuration files for selected language 
    CopyFiles "$INSTDIR\Languages\$R1\Jtv_$R1.ini" "$INSTDIR\Jtv.ini"
    CopyFiles "$INSTDIR\Languages\$R1\Readme_$R1.txt" "$INSTDIR\Readme.txt"
    CopyFiles "$INSTDIR\Languages\$R1\JTV Host_$R1.url" "$INSTDIR\JTV Host.url"
    CopyFiles "$INSTDIR\Languages\$R1\Remote.lng" "$INSTDIR\Languages\En\Remote.lng"
  AllDone:
    SetOutPath "$INSTDIR\"
FunctionEnd

; Select source files for custom language
Function SourceSelect
  StrCmp $R1 PL "" RUChk
   File "${SRC_LANG_DIR}\PL\*.*"
   Return
  RUChk:
  StrCmp $R1 RU "" BGChk
   File "${SRC_LANG_DIR}\RU\*.*"
   Return
  BGChk:
  StrCmp $R1 BG "" ROChk
   File "${SRC_LANG_DIR}\BG\*.*"
   Return
  ROChk:
  StrCmp $R1 RO "" TUChk
   File "${SRC_LANG_DIR}\RO\*.*"
   Return
  TUChk:
  StrCmp $R1 TU "" ITChk
   File "${SRC_LANG_DIR}\TU\*.*"
   Return
  ITChk:
  StrCmp $R1 IT "" SIChk
   File "${SRC_LANG_DIR}\IT\*.*"
   Return
  SIChk:
  StrCmp $R1 SV "" HUChk
   File "${SRC_LANG_DIR}\SV\*.*"
   Return
  HUChk:
  StrCmp $R1 HU "" SPChk
   File "${SRC_LANG_DIR}\HU\*.*"
   Return
  SPChk:
  StrCmp $R1 SP "" DEChk
   File "${SRC_LANG_DIR}\SP\*.*"
   Return
    DEChk:
  StrCmp $R1 DE "" XXChk
   File "${SRC_LANG_DIR}\DE\*.*"
   Return
  XXChk:
FunctionEnd

; $9 = counter
; $8 = DLL
; $7 = ini
Function .onInit
  StrCpy $9 -1
  GetTempFileName $8
  GetTempFileName $7
  File /oname=$8 InstallOptions.dll
  File /oname=$7 "jtv118.ini"
FunctionEnd

Function .onInstSuccess
  MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2 \
             "If you are interested in NSIS Installer, you may want to get script files of this installation as example.\
             $\rIf  Yes, they will be copied into $INSTDIR\_NSIS directory." \
          IDNO NoNSIS
       SetOutPath "$INSTDIR\_NSIS"
       File /r ${SRC_NSIS_DIR}\*.*
     SetOutPath $INSTDIR
  NoNSIS:
  Call Cleanup
  HideWindow
  IfFileExists "$SMPROGRAMS\${PRG_FLDR}\*.*" "" nofunshit
    ExecShell open '$SMPROGRAMS\${PRG_FLDR}'
    Sleep 1500
  nofunshit:
  MessageBox MB_YESNO|MB_ICONQUESTION \
             "Setup has completed. View readme file now?" \
             IDNO NoReadme
    ExecShell open '$INSTDIR\Readme.txt'
  NoReadme:
  MessageBox MB_YESNO|MB_ICONQUESTION \
             "You have to bind your TV card with JTV by choosing parameters in JTV, \
             and then bind JTVRemote with JTV by choosing the same parameters in \
             JTVConfig. Begin JTV configuration now?" \
             IDNO NoBegin
    Exec '$INSTDIR\JTV.exe'
  NoBegin:
FunctionEnd

Function .onInstFailed
  Call Cleanup
FunctionEnd

Function .onUserAbort
  Call Cleanup
FunctionEnd

Function Cleanup
  Delete $8
  Delete $7
FunctionEnd

Function .onNextPage
  StrCmp $9 1 good
    IntOp $9 $9 + 1
    Return
  good:
  Call RunConfigure
  Pop $0
  StrCmp $0 "cancel" "" nocancel
    Call Cleanup
    Quit
  nocancel:
  StrCmp $0 "back" "" noback
    Abort
  noback:
  IntOp $9 $9 + 1
FunctionEnd

Function .onPrevPage
  StrCmp $9 2 good
    IntOp $9 $9 - 1
    Return
  good:
  Call RunConfigure
  Pop $0
  StrCmp $0 "cancel" "" nocancel
    Call Cleanup
    Quit
  nocancel:
  StrCmp $0 "back" back
    Abort
  back:
  IntOp $9 $9 - 1
FunctionEnd

Function RunConfigure
  Push $7
  CallInstDLL $8 dialog
FunctionEnd

; uninstall stuff

UninstallText "Ready to remove JTV and all its components from your computer. \
               If JTV or JTVRemote is running, close them before continue.\
               $\rHit 'Uninstall' to continue."
; special uninstall section.
Section "Uninstall"
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRG_NAME}"
  DeleteRegKey HKLM "SOFTWARE\NSIS_${PRG_NAME}"
  ; remove files
  Delete $INSTDIR\*.txt
  Delete $INSTDIR\*.rm
  Delete $INSTDIR\*.log
  Delete $INSTDIR\*.ini
  Delete $INSTDIR\*.exe
  Delete $INSTDIR\*.dll
IfFileExists "$INSTDIR\*.chl" 0 KeepFile
  MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON1  \
           "Channel file(s) have been found in $INSTDIR directory. \
            Do you want to keep this file(s)?" \
            IDYES KeepFile 
  Delete $INSTDIR\*.chl  
KeepFile: 
  RMDir /r $INSTDIR\AppModules
  RMDir /r $INSTDIR\Artwork
  RMDir /r $INSTDIR\Cards
  RMDir /r $INSTDIR\ChannelTables
  RMDir /r $INSTDIR\Components
  RMDir /r $INSTDIR\Drivers
  RMDir /r $INSTDIR\Languages
  RMDir /r $INSTDIR\Remote
  RMDir /r $INSTDIR\Tuners
  RMDir /r $INSTDIR\TVGuide
  RMDir /r $INSTDIR\TxtCache
  RMDir /r $INSTDIR\_NSIS

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\${PRG_FLDR}\*.*"
  Delete "$SMSTARTUP\JTVRemote.lnk"
  Delete "$DESKTOP\JTV.lnk"
  Delete "$DESKTOP\JTVRemote.lnk"
  ; remove directories used.
  RMDir "$SMPROGRAMS\${PRG_FLDR}"
IfFileExists "$INSTDIR\*.chl" 0 NoChlFile
  MessageBox MB_OK "Note: Directory $INSTDIR could not be removed because some files \
                  are reserved!" IDOK 0
             Quit
NoChlFile:
  RMDir /r $INSTDIR
IfFileExists "$INSTDIR" 0 NoErrorMsg
  MessageBox MB_OK "Note: Directory $INSTDIR could not be removed because some files \
                  or directory are in use!" IDOK 0
NoErrorMsg:
SectionEnd

; eof
