; NSIS v2.0b0: jtv.nsi
;
; It will install JTV 3.0 wip 12.6 into a directory that the user selects.
;
; Installer vervion 
!define INS_VER_MAJOR 2
!define INS_VER_MINOR 02

; Program version
!define PRG_VER_MAJOR 3
!define PRG_VER_MINOR 12.6

; Source layouts: 
; c:\dst\jtv\main\... - all structure, but only \EN subdir
; c:\dst\jtv\lang\... - all languages subdirs except \EN
; c:\dst\jtv\nsis\... - installation NSIS files (as example)
!define SRC_MAIN_DIR c:\dst\jtv\main
!define SRC_LANG_DIR c:\dst\jtv\Lang
; !define SRC_NSIS_DIR c:\dst\jtv\NSIS

!define PRG_DIR JTV			; Default files directory name on drive
!define PRG_FLDR "JTV (Jaak TV)"	; Program folder name via Start/Programs
!define PRG_NAME "JTV 3.0 wip 12.6"	; Program name for Windows Registry	

; Installer parameters
Icon "jtv.ico"
CheckBitmap .\Contrib\Icons\lucas-checks.bmp
CRCCheck on

;----------- Install Language Page
LoadLanguageFile "${NSISDIR}\Contrib\Language files\English.nlf"
Name JTV
LoadLanguageFile "${NSISDIR}\Contrib\Language files\Russian.nlf"
Name JTV

Function .onInit
	Push ${LANG_ENGLISH}
	Push English
	Push ${LANG_RUSSIAN}
	Push "Russian ()"
	Push 2 ; 2 is the number of languages
	LangDLL::LangDialog "Installer Language" "Please select the language of the Installer"

	Pop $LANGUAGE
	StrCmp $LANGUAGE "cancel" 0 +2
		Abort
FunctionEnd

; --------- English language texts
BrandingText /LANG=${LANG_ENGLISH} "JTV Host Installer v${INS_VER_MAJOR}.${INS_VER_MINOR}"
LicenseText /LANG=${LANG_ENGLISH} "Read this to make shure, you know what you doing..."
LicenseData /LANG=${LANG_ENGLISH} ${SRC_MAIN_DIR}\Languages\En\license_en.txt
ComponentText /LANG=${LANG_ENGLISH} "This setup will install JTV ${PRG_VER_MAJOR}.0 wip (build) \
		${PRG_VER_MINOR} and JTVRemote 12.5 on your computer."
DirText /LANG=${LANG_ENGLISH} "Choose a directory to install in to:"
UninstallText /LANG=${LANG_ENGLISH} "Ready to remove JTV and all its components from your computer. \
               If JTV or JTVRemote is running, close them before continue.\
               $\rHit 'Uninstall' to continue."

LangString Sec1Name ${LANG_ENGLISH} "Install JTV main files (required)"
LangString Sec2Name ${LANG_ENGLISH} "Create Program Folder and Shortcuts"
LangString Sec3Name ${LANG_ENGLISH} "Load JTVRemote at System Startup"
LangString Sec4Name ${LANG_ENGLISH} "Create JTV Desktop Shortcut"
LangString Sec5Name ${LANG_ENGLISH} "Create JTVRemote Desktop Shortcut"

LangString LS_Caption ${LANG_ENGLISH} ": Interface Language Selection"

LangString MB_CheckDirIn ${LANG_ENGLISH} "Directory $INSTDIR already exists. Sure to install into anyway?"
; LangString MB_NSIS ${LANG_ENGLISH} "If you are interested in NSIS Installer, you may want to get script \
;		files of this installation as example.\
;             	$\rIf  Yes, they will be copied into $INSTDIR\_NSIS directory."
LangString MB_Readme ${LANG_ENGLISH} "Setup has completed. View readme file now?"
LangString MB_Config ${LANG_ENGLISH} "Now you have to bind your TV card with JTV by choosing parameters \
		in JTV, and then, if planning to use JTVRemote, bind it too by choosing the same parameters \
		in JTVConfig. Begin JTV configuration right now?"

; ------------ Russian language texts
BrandingText /LANG=${LANG_RUSSIAN} "JTV Host  v${INS_VER_MAJOR}.${INS_VER_MINOR}"
LicenseText /LANG=${LANG_RUSSIAN} "   ,    ..."
LicenseData /LANG=${LANG_RUSSIAN} ${SRC_LANG_DIR}\Ru\license_ru.txt
ComponentText /LANG=${LANG_RUSSIAN} "   JTV ${PRG_VER_MAJOR}.0 wip () \
		${PRG_VER_MINOR}  JTVRemote 12.5   ."
DirText /LANG=${LANG_RUSSIAN} "    :"
UninstallText /LANG=${LANG_RUSSIAN} "     JTV   . \
                JTV  JTVRemote ,   .\
               $\r   ''."

LangString Sec1Name ${LANG_RUSSIAN} "  JTV ()"
LangString Sec2Name ${LANG_RUSSIAN} "   "
LangString Sec3Name ${LANG_RUSSIAN} " JTVRemote  "
LangString Sec4Name ${LANG_RUSSIAN} " JTV   "
LangString Sec5Name ${LANG_RUSSIAN} " JTVRemote   "

LangString LS_Caption ${LANG_RUSSIAN} ":   "

LangString MB_CheckDirIn ${LANG_RUSSIAN} " $INSTDIR  .      ?"
; LangString MB_NSIS ${LANG_RUSSIAN} "   NSIS,        , \
;		$\r    .\
;		$\r ,      $INSTDIR\_NSIS."
LangString MB_Readme ${LANG_RUSSIAN} " .   Readme?"
LangString MB_Config ${LANG_RUSSIAN} "   ''     JTV,   \
		  JTV,  ,     JTVRemote, ''  ,  \
		     JTVConfig.   JTV  ?"
;---------------

; The file to write
OutFile "jtv${PRG_VER_MAJOR}w126.exe"

; The default installation directory
InstallDir $PROGRAMFILES\${PRG_DIR}
; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM SOFTWARE\${PRG_DIR} "Install_Dir"


InstType "Full"
InstType "Typical"
InstType "Standard"
InstType "Normal"
InstType "Minimal"
;InstType /NOCUSTOM
;InstType /COMPONENTSONLYONCUSTOM

;Order of pages
Page license
Page components
Page custom LanguageSelect $(LS_Caption)
Page directory
Page instfiles

; The stuff to be installed allways (1-st section)
Section $(Sec1Name)
  SectionIn 1 2 3 4 5 RO
  AddSize 300
; Check out path to the installation directory.
   IfFileExists "$INSTDIR\*.*" 0 NoSuchDir
     MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2  \
		    $(MB_CheckDirIn) \
                IDYES NoSuchDir 
                Quit
   NoSuchDir:


; Set output path to the installation directory.
  SetOutPath $INSTDIR
; Put file there
  File /r ${SRC_MAIN_DIR}\*.*
  CopyFiles "$INSTDIR\Languages\En\Jtv_en.ini" "$INSTDIR\Jtv.ini"
  CopyFiles "$INSTDIR\Languages\En\Readme_en.txt" "$INSTDIR\Readme.txt"
  CopyFiles "$INSTDIR\Languages\En\JTV Host_en.url" "$INSTDIR\JTV Host.url"
; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\NSIS_${PRG_DIR} "Install_Dir" "$INSTDIR"
; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRG_NAME}" \
                   "DisplayName" "${PRG_NAME} (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRG_NAME}" \
                   "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "uninstall.exe"

; ------This language select script block must be placed here in order to custom 
; celection files will be copied after the same common files and overwrite them
   ReadINIStr $R0 $R8 "Field 3" State ; $R0=Selected language
   StrCpy $R1 $R0 2                   ; $R1=Selected type
   ReadINIStr $R2 $R8 "Field 4" State ; $R2=Add all languages
   Call LanguageInstall
;------------
SectionEnd

; optional section
Section $(Sec2Name)
  SectionIn 1 2 3 4
  CreateDirectory "$SMPROGRAMS\${PRG_FLDR}"
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\Uninstall JTV.lnk" "$INSTDIR\uninstall.exe" "" \
                 "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\JTV 3.0 wip 12.6.lnk" "$INSTDIR\JTV.exe" "" \
                 "$INSTDIR\JTV.exe" 0
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\JTVRemote .lnk" "$INSTDIR\JTVRemote.exe" "" \
                 "$INSTDIR\JTVremote.exe" 0
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\JTVConfig.lnk" "$INSTDIR\JTVConfig.exe" "" \
                 "$INSTDIR\JTVConfig.exe" 0
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\Readme.lnk" "$INSTDIR\Readme.txt" "" \
                 "$INSTDIR\Readme.txt" 0
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\JTV Host.lnk" "$INSTDIR\JTV Host.url" "" \
                 "$INSTDIR\JTV Host.url" 0
;   WriteINIStr "$SMPROGRAMS\${PRG_FLDR}\JTV Host.url" \
;               "InternetShortcut" "URL" \
;		   "http://jtvhost.narod.ru/en/"
SectionEnd

; optional section
Section $(Sec3Name)
  SectionIn 1 2
  CreateShortCut "$SMSTARTUP\JTVRemote.lnk" "$INSTDIR\JTVRemote.exe" "" \
                 "$INSTDIR\JTVRemote.exe" 0
SectionEnd

; optional section
Section $(Sec4Name)
  SectionIn 1 3
  CreateShortCut "$DESKTOP\JTV.lnk" "$INSTDIR\JTV.exe"
SectionEnd

; optional section
Section $(Sec5Name)
  SectionIn 1 3
  CreateShortCut "$DESKTOP\JTVRemote.lnk" "$INSTDIR\JTVRemote.exe"
SectionEnd

Function LanguageSelect
; Display the Install Options dialog
; MessageBox MB_OK $LANGUAGE ; Use to find lang number
   GetTempFileName $R8
;   XXChk: ; ----- Xxxxxxxxx
;    StrCmp $LANGUAGE XXXX "" RUChk
;    File /oname=$R8 jtv202_XX.ini
;	Goto ChkF_OK 
;   RUChk: ; ----- Russian
   StrCmp $LANGUAGE 1049 "" ENChk
     File /oname=$R8 jtv202_ru.ini
	Goto ChkF_OK
    ENChk: ; ------- English - Default
    File /oname=$R8 jtv202_en.ini 
    ChkF_OK:

   InstallOptions::dialog $R8

   Pop $R9
   StrCmp $R9 "cancel" done
   StrCmp $R9 "back" done
   StrCmp $R9 "success" done
   MessageBox MB_OK|MB_ICONSTOP "InstallOptions error:$\r$\n$R9"
   done:
FunctionEnd

Function LanguageInstall
   StrCmp $R2 1 "" OneLang
   ; All languages added to selected and copied
    SetOutPath "$INSTDIR\Languages"
    File /r ${SRC_LANG_DIR}\*.*"
    DetailPrint "All Languages Added"
   OneLang:
   ; Only one language selected and copied
    StrCmp $R1 EN AllDone
    SetOutPath "$INSTDIR\Languages\$R1"
    DetailPrint "$R0 Language Selected"
    Call SourceSelect
    ; Prepare configuration files for selected language 
    CopyFiles "$INSTDIR\Languages\$R1\Jtv_$R1.ini" "$INSTDIR\Jtv.ini"
    CopyFiles "$INSTDIR\Languages\$R1\Readme_$R1.txt" "$INSTDIR\Readme.txt"
    CopyFiles "$INSTDIR\Languages\$R1\JTV Host_$R1.url" "$INSTDIR\JTV Host.url"
    CopyFiles "$INSTDIR\Languages\$R1\Remote.lng" "$INSTDIR\Languages\En\Remote.lng"
  AllDone:
    SetOutPath "$INSTDIR\"
FunctionEnd

; Select source files for custom language
Function SourceSelect
  StrCmp $R1 PL "" RUChk
   File "${SRC_LANG_DIR}\PL\*.*"
   Return
  RUChk:
  StrCmp $R1 RU "" BGChk
   File "${SRC_LANG_DIR}\RU\*.*"
   Return
  BGChk:
  StrCmp $R1 BG "" ROChk
   File "${SRC_LANG_DIR}\BG\*.*"
   Return
  ROChk:
  StrCmp $R1 RO "" TUChk
   File "${SRC_LANG_DIR}\RO\*.*"
   Return
  TUChk:
  StrCmp $R1 TU "" ITChk
   File "${SRC_LANG_DIR}\TU\*.*"
   Return
  ITChk:
  StrCmp $R1 IT "" SIChk
   File "${SRC_LANG_DIR}\IT\*.*"

   Return
  SIChk:
  StrCmp $R1 SV "" HUChk
   File "${SRC_LANG_DIR}\SV\*.*"
   Return
  HUChk:
  StrCmp $R1 HU "" SPChk
   File "${SRC_LANG_DIR}\HU\*.*"
   Return
  SPChk:
  StrCmp $R1 SP "" DEChk
   File "${SRC_LANG_DIR}\SP\*.*"
   Return
    DEChk:
  StrCmp $R1 DE "" XXChk
   File "${SRC_LANG_DIR}\DE\*.*"
   Return
  XXChk:
FunctionEnd

Function .onInstSuccess
;  MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2 \
;       $(MB_NSIS) \
;       IDNO NoNSIS
;       SetOutPath "$INSTDIR\_NSIS"
;       File /r ${SRC_NSIS_DIR}\*.*
;     SetOutPath $INSTDIR
;  NoNSIS:
  Call Cleanup
  HideWindow
  IfFileExists "$SMPROGRAMS\${PRG_FLDR}\*.*" "" nofunshit
    ExecShell open '$SMPROGRAMS\${PRG_FLDR}'
    Sleep 1500
  nofunshit:
  MessageBox MB_YESNO|MB_ICONQUESTION \
             $(MB_Readme) \
             IDNO NoReadme
    ExecShell open '$INSTDIR\Readme.txt'
  NoReadme:
  MessageBox MB_YESNO|MB_ICONQUESTION \
             $(MB_Config) \
             IDNO NoBegin
    Exec '$INSTDIR\JTV.exe'
  NoBegin:
FunctionEnd

Function .onInstFailed
  Call Cleanup
FunctionEnd

Function .onUserAbort
  Call Cleanup
FunctionEnd

Function Cleanup
  Delete $R8
  Delete $R9
FunctionEnd


Function CheckCHL

FunctionEnd

; uninstall stuff

; special uninstall section.
Section "Uninstall"
  ; Get default language identifier from registry
  ReadRegStr $0 HKU ".DEFAULT\Control Panel\International" "Locale" 
  ; MessageBox MB_OK $0 ; View number
; ----- Xxxxxxx
;    ChkU_XX:
;  StrCmp $0 00000XXX "" ChkU_RU      	
;	StrCpy $1 "Xxxxxx"
;    	StrCpy $2 "Yyyyyy" 
;	StrCpy $3 "Zzzzzzz" 
;    GoTo ChkU_OK 
; ----- Russian
;    ChkU_RU:
  StrCmp $0 00000419 "" ChkU_EN      	
	StrCpy $1 "  $INSTDIR () ()  . $\r    ()?"
     	StrCpy $2 ":  $INSTDIR  ,    !" 
	StrCpy $3 ":  $INSTDIR  ,      !" 
    GoTo ChkU_OK 
; ----- English - Default
     ChkU_EN:
 	StrCpy $1 "Channel file(s) have been found in $INSTDIR directory. $\rDo you want to keep this file(s)?" 
  	StrCpy $2 "Note: Directory $INSTDIR could not be removed because some files are reserved!"
  	StrCpy $3 "Note: Directory $INSTDIR could not be removed because some files or directory are in use!"
    ChkU_OK:
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRG_NAME}"
  DeleteRegKey HKLM "SOFTWARE\NSIS_${PRG_NAME}"
  ; Remove files
  Delete $INSTDIR\*.txt
  Delete $INSTDIR\*.rm
  Delete $INSTDIR\*.log
  Delete $INSTDIR\*.ini
  Delete $INSTDIR\*.exe
  Delete $INSTDIR\*.dll
  Delete $INSTDIR\*.url
  IfFileExists "$INSTDIR\*.chl" 0 KeepFile
	 MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON1  $1 IDYES KeepFile  
   	Delete $INSTDIR\*.chl  
  KeepFile: 
  RMDir /r $INSTDIR\AppModules
  RMDir /r $INSTDIR\Artwork
  RMDir /r $INSTDIR\Cards
  RMDir /r $INSTDIR\ChannelTables

  RMDir /r $INSTDIR\Components
  RMDir /r $INSTDIR\Drivers
  RMDir /r $INSTDIR\Languages
  RMDir /r $INSTDIR\Remote
  RMDir /r $INSTDIR\Tuners
  RMDir /r $INSTDIR\TVGuide
  RMDir /r $INSTDIR\TxtCache
;  RMDir /r $INSTDIR\_NSIS
  ; Remove shortcuts, if any.
  Delete "$SMPROGRAMS\${PRG_FLDR}\*.*"
  Delete "$SMSTARTUP\JTVRemote.lnk"
  Delete "$DESKTOP\JTV.lnk"
  Delete "$DESKTOP\JTVRemote.lnk"
  ; Remove directories used.

  RMDir "$SMPROGRAMS\${PRG_FLDR}"

  IfFileExists "$INSTDIR\*.chl" 0 NoChlFile
 	MessageBox MB_OK|MB_ICONINFORMATION $2 IDOK 0
             Quit
   NoChlFile:
   RMDir /r $INSTDIR
   IfFileExists "$INSTDIR" 0 NoErrorMsg
 	MessageBox MB_OK|MB_ICONINFORMATION $3  IDOK 0
   NoErrorMsg:
SectionEnd

; eof
