; http://www.nullsoft.com/free/nsis/ 
; NSIS v2.0b0/b1: la.nsi
;
; It will install Light Alloy into a directory that the user selects.
;
; Installer vervion 
!define INS_VER_MAJOR 2
!define INS_VER_MINOR ".03"
; !define INI_NAME la201 ; b0 Common file name for language specific select page	
!define INI_NAME la202 ; b1 Common file name for language specific select page

; Program version
!define PRG_VER_MAJOR 2
!define PRG_VER_MINOR ".0"

; Source layouts:
!define SRC_MAIN_DIR c:\dst\la	; - main files subdir
!define SRC_LANG_DIR c:\dst\la\langs	; - all languages subdirs
!define SRC_SKIN_DIR c:\dst\la\skins	; - skins subdir
!define SRC_HELP_DIR c:\dst\la\help	; - help subdir
!define SRC_FILTER_DIR c:\dst\la\filters	; - filter subdir
!define SRC_WINAMP_DIR c:\dst\la\winamp	; - winamp subdir
!define SRC_REPORT_DIR c:\dst\la\report	; - report subdir
!define SRC_NSIS_DIR c:\dst\la\nsis	; - installation NSIS files

; Program identifiers
!define PRG_DIR "Light Alloy"			; Default files subdir name on drive
!define NSIS_DIR $PROGRAMFILES\NSIS	; Full path to NSIS script dir
!define PRG_FLDR "Light Alloy"	; Program folder name via Start/Programs
!define PRG_SHORT "LA"		; Program short name
!define PRG_BASIC "Light Alloy"	; Program basic name	
!define PRG_NAME "Light Alloy ${PRG_VER_MAJOR}${PRG_VER_MINOR}"; Program full name	

; Installer parameters
Icon la.ico
CheckBitmap .\Contrib\Icons\lucas-checks.bmp
CRCCheck on

; The file to write
OutFile "la2setup.exe"

;----------- Install Language Page
LoadLanguageFile "${NSISDIR}\Contrib\Language files\English.nlf"
Name "${PRG_BASIC}"
LoadLanguageFile "${NSISDIR}\Contrib\Language files\Russian.nlf"
Name "${PRG_BASIC}"

Function .onInit
	Push ${LANG_ENGLISH}
	Push English
	Push ${LANG_RUSSIAN}
	Push "Russian ()"
	Push 2 ; 2 is the number of languages
	LangDLL::LangDialog "Installer Language" "Please select the language of the Installer \
								$\r  "

	Pop $LANGUAGE
	StrCmp $LANGUAGE "cancel" 0 +2
		Abort

FunctionEnd

; --------- English language texts
BrandingText /LANG=${LANG_ENGLISH} "${PRG_SHORT} Installer v${INS_VER_MAJOR}${INS_VER_MINOR}"
LicenseText /LANG=${LANG_ENGLISH} "Read this to make shure, you know what you doing..."
LicenseData /LANG=${LANG_ENGLISH} "${SRC_MAIN_DIR}\license_en.txt"
ComponentText /LANG=${LANG_ENGLISH} "Select options for install ${PRG_NAME} on your computer."
DirText /LANG=${LANG_ENGLISH} "Choose a directory to install in to:"
UninstallText /LANG=${LANG_ENGLISH} "Ready to remove ${PRG_NAME} and all its components from your computer. \
               If ${PRG_BASIC} is running, close it before continue.\
               $\rHit 'Uninstall' to continue."

LangString Sec1Name ${LANG_ENGLISH} "Main Executable File (required)"
LangString Sec2Name ${LANG_ENGLISH} "Other Files and Uninstaller"
LangString Sec3Name ${LANG_ENGLISH} "Program Folder and Shortcuts"
LangString Sec4Name ${LANG_ENGLISH} "Desktop ${PRG_SHORT} Shortcut"
LangString Sec5Name ${LANG_ENGLISH} "Additional Skins"
LangString Sec6Name ${LANG_ENGLISH} "Additional Language Files"
LangString Sec601Name ${LANG_ENGLISH} "English"
LangString Sec602Name ${LANG_ENGLISH} "Russian"
LangString Sec603Name ${LANG_ENGLISH} "German"

LangString LS_Caption ${LANG_ENGLISH} ": Interface Language Selection"

LangString MB_CheckDirIn ${LANG_ENGLISH} "Directory $INSTDIR already exists. Sure to install into anyway?"
LangString MB_OldIni ${LANG_ENGLISH} "Configuration file have been found in $INSTDIR directory. $\rDo you want to use this file?" 
LangString MB_NSIS ${LANG_ENGLISH} "If you are interested in NSIS Installer, you may want to get script \
		files of this installation as example.\
          	$\rIf  Yes, they will be copied into ${NSIS_DIR} directory."
LangString MB_Readme ${LANG_ENGLISH} "Setup has completed. View readme file now?"

; ------------ Russian language texts
BrandingText /LANG=${LANG_RUSSIAN} "${PRG_SHORT}  v${INS_VER_MAJOR}${INS_VER_MINOR}"
LicenseText /LANG=${LANG_RUSSIAN} "   ,    ..."
LicenseData /LANG=${LANG_RUSSIAN} ${SRC_MAIN_DIR}\license_ru.txt
ComponentText /LANG=${LANG_RUSSIAN} "   ${PRG_NAME}   ."
DirText /LANG=${LANG_RUSSIAN} "    :"
UninstallText /LANG=${LANG_RUSSIAN} "     ${PRG_NAME}   . \
                ${PRG_BASIC} ,   .\
               $\r   ''."

LangString Sec1Name ${LANG_RUSSIAN} "  ()"
LangString Sec2Name ${LANG_RUSSIAN} "   "
LangString Sec3Name ${LANG_RUSSIAN} "   "
LangString Sec4Name ${LANG_RUSSIAN} "   "
LangString Sec5Name ${LANG_RUSSIAN} " "
LangString Sec6Name ${LANG_RUSSIAN} " "
LangString Sec601Name ${LANG_RUSSIAN} ""
LangString Sec602Name ${LANG_RUSSIAN} ""
LangString Sec603Name ${LANG_RUSSIAN} ""

LangString LS_Caption ${LANG_RUSSIAN} ":   "

LangString MB_CheckDirIn ${LANG_RUSSIAN} " $INSTDIR  .      ?"
LangString MB_OldIni ${LANG_RUSSIAN} "  $INSTDIR    . $\r   ?"
LangString MB_NSIS ${LANG_RUSSIAN} "   NSIS,        , \
		$\r    .\
		$\r ,      ${NSIS_DIR}."
LangString MB_Readme ${LANG_RUSSIAN} " .   Readme?"
;---------------

; The default installation directory
InstallDir "$PROGRAMFILES\${PRG_DIR}"
; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "SOFTWARE\${PRG_DIR}" "Install_Dir"


InstType "Full"
InstType "Standard"
InstType "Hidden"
InstType "Tiny"
;InstType /NOCUSTOM
;InstType /COMPONENTSONLYONCUSTOM


;Order of pages
Page license
Page custom LanguageSelect $(LS_Caption)
Page components
Page directory
Page instfiles

; Interface language select page
Function LanguageSelect
; Display the Install Options dialog
; MessageBox MB_OK $LANGUAGE ; ----- Use to display new lang number
   GetTempFileName $R8
;   XXChk: ; ----- Xxxxxxxxx
;    StrCmp $LANGUAGE XXXX "" RUChk
;    File /oname=$R8 ${INI_NAME}_XX.ini;
;	Goto ChkF_OK 
;   RUChk: ; ----- Russian

   StrCmp $LANGUAGE 1049 "" ENChk
     File /oname=$R8 ${INI_NAME}_ru.ini
	Goto ChkF_OK
    ENChk: ; ------- English - Default
    File /oname=$R8 ${INI_NAME}_en.ini 
    ChkF_OK:

   InstallOptions::dialog $R8

   ReadINIStr $R0 $R8 "Field 3" State ; $R0=Selected language

   StrCpy $R1 $R0 2                   ; $R1=Selected type
;   ReadINIStr $R2 $R8 "Field 4" State ; $R2=Add all languages

   Pop $R9
   StrCmp $R9 "cancel" done
   StrCmp $R9 "back" done
   StrCmp $R9 "success" done
   MessageBox MB_OK|MB_ICONSTOP "InstallOptions error:$\r$\n$R9"
   done:
FunctionEnd

; Select source files for custom language
Function SourceSelect
  StrCmp $R1 En "" RuChk
;   SetOutPath "$INSTDIR\Langs"
;   File "${SRC_LANG_DIR}\English.lal"
   SetOutPath "$INSTDIR\Help"
   File "${SRC_HELP_DIR}\English.chm"
   Return
  RUChk:
  StrCmp $R1 Ru "" GeChk
;   SetOutPath "$INSTDIR\Langs"
;   File "${SRC_LANG_DIR}\Russian.lal"
   SetOutPath "$INSTDIR\Help"
   File "${SRC_HELP_DIR}\Russian.chm"
   Return
  GeChk:
  StrCmp $R1 Ge "" XxChk
   SetOutPath "$INSTDIR\Langs"
   File "${SRC_LANG_DIR}\German*.lal"
;   SetOutPath "$INSTDIR\Help"
;   File "${SRC_HELP_DIR}\German.chm"
   Return
   XxChk:
FunctionEnd

; The stuff to be installed allways (1-st section)
Section $(Sec1Name)
  SectionIn 1 2 3 4 RO
; Check out path to the installation directory.
   IfFileExists "$INSTDIR\*.*" 0 NoTagDir
     MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2 $(MB_CheckDirIn) IDYES NoTagDir 
                Quit 
   NoTagDir:
 ; Set output path and file to be installed to the installation directory.
  SetOutPath $INSTDIR
  DetailPrint "$R0 Language Selected"
  File ${SRC_MAIN_DIR}\la.exe
  IfFileExists "$INSTDIR\la.ini" 0 NewIni
	MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON1  $(MB_OldIni) IDYES OldIni  	
	NewIni:   	
	File "${SRC_MAIN_DIR}\LA_*.ini"
	Rename "$INSTDIR\LA_$R1.ini" "$INSTDIR\LA.ini"
	Delete "$INSTDIR\LA_*.ini"
	OldIni: 
SectionEnd

; optional section
Section $(Sec2Name)
  SectionIn 1 2 3
  SetOutPath $INSTDIR\Filters
  File ${SRC_FILTER_DIR}\*.*
  SetOutPath $INSTDIR\WinAMP
  File ${SRC_WINAMP_DIR}\*.*
  SetOutPath $INSTDIR\Report
  File ${SRC_REPORT_DIR}\*.*
  SetOutPath $INSTDIR\Langs
  File "${SRC_LANG_DIR}\English*.lal"
   SetOutPath $INSTDIR
  File "${SRC_MAIN_DIR}\Readme_*.txt"
  Rename "$INSTDIR\Readme_$R1.txt" "$INSTDIR\Readme.txt"
  Delete "$INSTDIR\Readme_*.txt"
  File "${SRC_MAIN_DIR}\License_*.txt"
  IfFileExists "$INSTDIR\License_$R1.txt" LngLic EngLic
	LngLic:
	Rename "$INSTDIR\License_$R1.txt" "$INSTDIR\License.txt"
	GoTo EndLic
	EngLic:
	Rename "$INSTDIR\License_en.txt" "$INSTDIR\License.txt"
  EndLic:
  Delete "$INSTDIR\License_*.txt"

    Call SourceSelect

; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\NSIS_${PRG_DIR}" "Install_Dir" "$INSTDIR"
; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRG_NAME}" \
                   "DisplayName" "${PRG_NAME} (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRG_NAME}" \
                   "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "uninstall.exe"
;   Call LanguageInstall
SectionEnd

; optional section
Section $(Sec3Name)
  SectionIn 1 2
  CreateDirectory "$SMPROGRAMS\${PRG_FLDR}"
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\Uninstall ${PRG_SHORT}.lnk" "$INSTDIR\uninstall.exe" "" \
                 "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\${PRG_NAME}.lnk" "$INSTDIR\la.exe" "" \
                 "$INSTDIR\la.exe" 0
   IfFileExists "$INSTDIR\Readme.txt" "" NoRLink
	CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\Readme.lnk" "$INSTDIR\Readme.txt" "" \
                 "$INSTDIR\Readme.txt" 0
     NoRLink:
;  CreateShortCut "$SMPROGRAMS\${PRG_FLDR}\${PRG_SHORT} Home.lnk" "$INSTDIR\LA Home.url" "" \
;                 "$INSTDIR\LA Home.url" 0
   WriteINIStr "$SMPROGRAMS\${PRG_FLDR}\${PRG_SHORT} Home.url" \
                "InternetShortcut" "URL" \
     		   "http://la.video-soft.com/"
SectionEnd

; optional section
Section $(Sec4Name) 
    SectionIn 1 2
    CreateShortCut "$DESKTOP\${PRG_BASIC}.lnk" "$INSTDIR\la.exe"
SectionEnd

; optional section
Section $(Sec5Name) 
    SectionIn 1
    SetOutPath "$INSTDIR\Skins"
; Put file there
  File /r ${SRC_SkIN_DIR}\*.*
SectionEnd

; optional section
SubSection $(Sec6Name)
 Section $(Sec601Name) ; English 
    SectionIn 1
     SetOutPath "$INSTDIR\Help"
     File "${SRC_HELP_DIR}\English.chm"
;     SetOutPath "$INSTDIR\Langs"
;     File "${SRC_LANG_DIR}\English.lal"
  SectionEnd
  Section $(Sec602Name) ; Russian
     SectionIn 1
     SetOutPath "$INSTDIR\Help"
     File "${SRC_HELP_DIR}\Russian.chm"
;     SetOutPath "$INSTDIR\Langs"
;     File "${SRC_LANG_DIR}\Russian*.lal"
  SectionEnd
  Section $(Sec603Name) ; German
     SectionIn 1
;     SetOutPath "$INSTDIR\Help"
;     File "${SRC_HELP_DIR}\German.chm"
     SetOutPath "$INSTDIR\Langs"

     File "${SRC_LANG_DIR}\German*.lal"
  SectionEnd
SubSectionEnd

Function .onInstSuccess
  MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2 \
       $(MB_NSIS) \
       IDNO NoNSIS
       SetOutPath ${NSIS_DIR}
       File /r ${SRC_NSIS_DIR}\*.*
     SetOutPath $INSTDIR
  NoNSIS:
  HideWindow
  IfFileExists "$SMPROGRAMS\${PRG_FLDR}\*.*" "" nofunshit
    ExecShell open '$SMPROGRAMS\${PRG_FLDR}'
    Sleep 1500
  nofunshit:
   IfFileExists "$INSTDIR\Readme.txt" "" NoReadme
      MessageBox MB_YESNO|MB_ICONQUESTION \
             $(MB_Readme) \
             IDNO NoReadme
    ExecShell open '$INSTDIR\Readme.txt'
  NoReadme:
FunctionEnd

; special uninstall section.
Section "Uninstall"
  ; Get default language identifier from registry
  ReadRegStr $0 HKU ".DEFAULT\Control Panel\International" "Locale" 
  ; MessageBox MB_OK $0 ; View number
; ----- Xxxxxxx
;    ChkU_XX:

;  StrCmp $0 00000XXX "" ChkU_RU      	
;	StrCpy $1 "Xxxxxx"
;    	StrCpy $2 "Yyyyyy" 
;	StrCpy $3 "Zzzzzzz" 
;    GoTo ChkU_OK 
; ----- Russian
;    ChkU_RU:
  StrCmp $0 00000419 "" ChkU_EN      	
	StrCpy $1 "  $INSTDIR    . $\r   ?"
    	StrCpy $2 "!  $INSTDIR  ,    !" 
	StrCpy $3 "!  $INSTDIR  ,      !" 
    GoTo ChkU_OK 
; ----- English - Default
     ChkU_EN:
	StrCpy $1 "Configuration file have been found in $INSTDIR directory. $\rDo you want to keep this file?" 
  	StrCpy $2 "Note! Directory $INSTDIR could not be removed because some files are reserved!"
  	StrCpy $3 "Note! Directory $INSTDIR could not be removed because some files or directory are in use!"
    ChkU_OK:
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRG_NAME}"
  DeleteRegKey HKLM "SOFTWARE\NSIS_${PRG_NAME}"
  ; Remove files
   IfFileExists "$INSTDIR\*.ini" 0 KeepIni
	 MessageBox MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON1  $1 IDYES KeepIni  
   	Delete $INSTDIR\*.ini  
  KeepIni: 
   Delete $INSTDIR\*.lap
   Delete $INSTDIR\*.txt
  Delete $INSTDIR\*.exe
  Delete $INSTDIR\*.url
  RMDir /r $INSTDIR\Skins
  RMDir /r $INSTDIR\Filters

  RMDir /r $INSTDIR\WinAMP
  RMDir /r $INSTDIR\Help
  RMDir /r $INSTDIR\Report
  RMDir /r $INSTDIR\Langs
  ; Remove shortcuts, if any.
  Delete "$SMPROGRAMS\${PRG_FLDR}\*.*"
   Delete "$DESKTOP\${PRG_BASIC}.lnk"
  ; Remove directories used.

  RMDir "$SMPROGRAMS\${PRG_FLDR}"
 IfFileExists "$INSTDIR\*.ini" 0 NoIniFile
 	MessageBox MB_OK|MB_ICONINFORMATION $2 IDOK 0
             Quit
   NoIniFile:
  RMDir /r $INSTDIR
   IfFileExists "$INSTDIR" 0 NoErrorMsg
 	MessageBox MB_OK|MB_ICONINFORMATION $3  IDOK 0
   NoErrorMsg:
SectionEnd
; eof
